<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            max-height: 70%;
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"><h3>logged in as {{user}}</h3></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <input type="hidden" id="sender" name="sender" value={{user}}>
            <label for="recipient">To:</label>
            <input type="text" id="recipient" name="recipient">
            <button type="button" id="sendBtn">Send</button>
            <span></span>
            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;">A message...</textarea>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var senderField = document.getElementById('sender');
    var messageField = document.getElementById('message');
    var recipientField = document.getElementById('recipient');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');
    const recmes = [];

    var search = async (query, user) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}&u=${encodeURIComponent(user)}`;
        res = await fetch(q);
        response = await res.text()
        response = JSON.parse(response)
        for(let i = 0; i<response.length; i++){
            console.log(response[i])
            if (!recmes.includes(response[i][0])){
                recmes.push(response[i][0])
                const body = document.createElement('p');
                body.innerHTML = `To: ${response[i][3]}<br>From: ${response[i][1]}<br>${response[i][2]}`;
                output.appendChild(body);
                body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
                anchor.scrollIntoView();
            }
        }
        var objDiv = document.getElementById("page");
        objDiv.scrollTop = objDiv.scrollHeight;
    };
    var send = async (sender, message, recipient) => {
        const id = reqId++;
        const q = `/send?sender=${encodeURIComponent(sender)}&message=${encodeURIComponent(message)}&recipient=${encodeURIComponent(recipient)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        search("*", sender)
    };

    sendBtn.addEventListener('click', () => send(senderField.value, messageField.value, recipientField.value));

    setInterval(function() {search("*", senderField.value)}, 100);
</script>

</html>